/*
 * Charger.c
 *
 *  Created on: Jan 29, 2018
 *      Author: Tomas
 */


#include "Charger.h"


ChargerStatus isChargerActive() {

	if ( HAL_GPIO_ReadPin( CHG_GPIO_Port, CHG_Pin ) == GPIO_PIN_RESET && HAL_GPIO_ReadPin( RECT_GPIO_Port, RECT_Pin ) == GPIO_PIN_SET ) {
		return DEVICE_CHARGING;
	}else if ( HAL_GPIO_ReadPin( CHG_GPIO_Port, CHG_Pin ) == GPIO_PIN_SET && HAL_GPIO_ReadPin( RECT_GPIO_Port, RECT_Pin ) == GPIO_PIN_SET ){
		return CHARGER_IN_RANGE;
	}else{
		return DEVICE_NOT_CHARGING;
	}
}
