/*
 * LIS3MDL.c
 *
 *  Created on: Jul 31, 2017
 *      Author: Tomas
 */
#include "LIS3MDL.h"
extern UART_HandleTypeDef huart2;
extern I2C_HandleTypeDef hi2c1;

void LIS3MDLPowerOn() {
	//HAL_GPIO_WritePin(V_ACC_GPIO_Port, V_ACC_Pin, GPIO_PIN_SET);
}

void LIS3MDLPowerOff() {
	HAL_GPIO_WritePin(V_ACC_GPIO_Port, V_ACC_Pin, GPIO_PIN_RESET);
}

void LIS3MDLinit() {
	MX_I2C1_Init();
	//MX_I2C1_Init();
	LIS3MDLPowerOn();
	HAL_Delay( 1000 );
	LIS3MDLNormalConfig();

	//HAL_I2C_DeInit( &hi2c1 );

}

void LIS3MDLoff() {
	LIS3MDLPowerOff();
	HAL_I2C_DeInit( &hi2c1 );
}


void LIS3MDLNormalConfig() {
	 LIS3MDLsetControlregister1();

}

void LIS3MDLsetControlregister1() {

	uint8_t new_data_reg = 0;

	uint8_t addr = 0;

	HAL_I2C_Mem_Read( &hi2c1, LIS3MDL_I2C_ADDR, 0x0F, 1, &addr, 1, 1000 );

	if ( addr == 0 ) {
		asm( "nop" );
	}

	new_data_reg = 0b01010000;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x20, 1, &new_data_reg, 1, 1000 ) == HAL_OK ) {
		asm( "nop" );
	}
/*
	new_data_reg = 0;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x21, 1, &new_data_reg, 1, 1000 ) == HAL_OK ) {
	}
*/
	new_data_reg = 0b00000010;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x22, 1, &new_data_reg, 1, 1000 ) == HAL_OK ) {
	}

	new_data_reg = 0b01000000;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x23, 1, &new_data_reg, 1, 1000 ) == HAL_OK ) {
	}

	new_data_reg = 0b00000000;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x25, 1, &new_data_reg, 1, 1000 ) == HAL_OK ) {
	}
/*
	new_data_reg = 0b01111000;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x24, 1, &new_data_reg, 1, 1000 ) == HAL_OK ) {
	}

*/
	new_data_reg = 0b00001000;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x30, 1, &new_data_reg, 1, 1000 ) == HAL_OK ) {
	}


	new_data_reg = 0b00000100;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x31, 1, &new_data_reg, 1, 200 ) == HAL_OK ) {
	}
	new_data_reg = 0b11100100;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x32, 1, &new_data_reg, 1, 200 ) == HAL_OK ) {
	}

	new_data_reg = 0b00000100;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x33, 1, &new_data_reg, 1, 200 ) == HAL_OK ) {
	}

	new_data_reg = 0b10000000;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x34, 1, &new_data_reg, 1, 200 ) == HAL_OK ) {
	}

	new_data_reg = 0b00100000;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x3F, 1, &new_data_reg, 1, 200 ) == HAL_OK ) {
	}

/*
	new_data_reg = 0x00;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x25, 1, &new_data_reg, 1, 1000 ) == HAL_OK ) {
	}
	*/
	/*
	new_data_reg = 0x88;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x26, 1, &new_data_reg, 1, 200 ) == HAL_OK ) {
	}
*/
	/*
	new_data_reg = 0x15;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x38, 1, &new_data_reg, 1, 1000 ) == HAL_OK ) {
	}


	new_data_reg = 0x18;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x3A, 1, &new_data_reg, 1, 1000 ) == HAL_OK ) {
	}
	new_data_reg = 0x50;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x3B, 1, &new_data_reg, 1, 1000 ) == HAL_OK ) {
	}

	new_data_reg = 0x10;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x3C, 1, &new_data_reg, 1, 1000 ) == HAL_OK ) {
	}


	new_data_reg = 0x10;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x3D, 1, &new_data_reg, 1, 1000 ) == HAL_OK ) {
	}
	*/
/*
	new_data_reg = 0x0;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x31, 1, &new_data_reg, 1, 200 ) == HAL_OK ) {
	}
/

	new_data_reg = 0x09;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x33 ,1, &new_data_reg, 1, 200 ) == HAL_OK ) {
	}
	/*
	new_data_reg = 10;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x3B, 1, &new_data_reg, 1, 200 ) == HAL_OK ) {
	}
	new_data_reg = 2;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x3C, 1, &new_data_reg, 1, 200 ) == HAL_OK ) {
	}
	new_data_reg = 2;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x3D, 1, &new_data_reg, 1, 200 ) == HAL_OK ) {
	}
*/
	/*
	new_data_reg |= 0 <<  7;
	new_data_reg |= 1 << 6;
	new_data_reg |= 1 << 5;
	new_data_reg |= 1 << 4;

	new_data_reg |= 0 << 3;
	new_data_reg |= 1 << 2;
	new_data_reg |= 1 << 1;
	new_data_reg |= 1;
	*/
/*
	new_data_reg = 0x80;
	if ( HAL_I2C_Mem_Write( &hi2c1, LIS3MDL_I2C_ADDR, 0x24, 1, &new_data_reg, 1, 200 ) == HAL_OK ) {
	}
*/
/*
	new_data_reg = 0x15;
	HAL_I2C_Mem_Write(&hi2c1, LIS3MDL_I2C_ADDR, 0x38, 1, &new_data_reg, 1, 1000);
	HAL_Delay( 4000 );
*/
}


void LIS3MDLclearInterrupt() {
	__HAL_RCC_I2C1_CLK_ENABLE();
	while (HAL_I2C_DeInit( &hi2c1 ) != HAL_OK);
	MX_I2C1_Init();
	uint8_t storage = 0;
	if ( HAL_I2C_Mem_Read( &hi2c1, LIS3MDL_I2C_ADDR, 0x39, 1, &storage, 1, 1000 ) != HAL_OK ) {

	}

	__HAL_RCC_I2C1_CLK_DISABLE();
	//HAL_I2C_DeInit( &hi2c1 );
}



