/*
 * murata.h
 *
 *  Created on: Aug 18, 2017
 *      Author: fiala
 */

#ifndef MURATA_H_
#define MURATA_H_

#include "main.h"
#include "usart.h"
#include "gpio.h"
#include "uartRxBuff.h"
#include "led.h"
#define DEFAULT_UART_TIMEOUT 1500
#define DEFAULT_UART_COMMAND_TIMEOUT 500

extern MainDevice mDevice;
#define NO_COMMANDS 3


void lora_init(void);
void lora_join_network();
void lora_on ( void );
void lora_off( void );
void lora_UART_Init(void);
void lora_set_power( char * command );
uint8_t lora_recv_msg();
#endif /* MURATA_H_ */
