/*
 * init.h
 *
 *  Created on: Nov 24, 2016
 *      Author: Tomas
 */

#ifndef MEMORY_H_
#define MEMORY_H_

//#define FLASH_USER_START_ADDR   ((uint32_t)0x08008000)   /* Start @ of user Flash area */
//#define FLASH_USER_END_ADDR     ((uint32_t)0x0801F800) + FLASH_PAGE_SIZE   /* End @ of user Flash area */

#include "stm32l0xx_hal.h"
#include "main.h"
#include "stm32l0xx_hal_flash.h"
typedef struct FlashMemory {

	uint16_t start;
	uint8_t mode;



} FlashMemory;


#define FLASH_USER_START_ADDR    ((uint32_t)0x08080000)    /* Start @ of user Flash area */

#define STATE_POS 0x080071B8


typedef enum FlashWriteStatus {
	FLASH_OK, FLASH_ERROR
} FlashWriteStatus ;
FlashWriteStatus writeToMem( uint32_t Address, uint8_t data32 );
uint8_t readFromMem( uint64_t Address );
FlashWriteStatus readModeFromFlash( PetTrackerModes * res );
#endif /* INIT_H_ */
