/*
 * murata.h
 *
 *  Created on: Aug 18, 2017
 *      Author: fiala
 */

#ifndef MURATA_H_
#define MURATA_H_

#include "main.h"
#include "gpio.h"
#include "usart.h"
#include "macros.h"
#include "uartRxBuff.h"

#define DEFAULT_UART_TIMEOUT 500
#define DEFAULT_UART_COMMAND_TIMEOUT 500



void murata_init(void);
void murata_join_network();
void murata_send( char * str, uint8_t len );
void murata_send_periodic_data( char * data );
void murata_send_n_bytes( char * data , uint8_t n);
void murata_on ( void );
void murata_off( void );
void murate_send_bytes( char * str, uint8_t len );
uint8_t lora_recv_msg();

#endif /* MURATA_H_ */
